aboutsummaryrefslogtreecommitdiffhomepage
diff options
context:
space:
mode:
authorGravatar Laszlo Csomor <laszlocsomor@google.com>2017-07-27 11:34:09 +0200
committerGravatar Damien Martin-Guillerez <dmarting@google.com>2017-07-27 13:00:19 +0200
commit3d21578895bc6d1fb153fec3cea9810396abf78e (patch)
treeece01b13c27f29f2d53ff6fa0e70318ec5a8b56e
parentb1ae955caf91b2f64e8d5be7242166864ae1cb64 (diff)
Windows: Bazel now has an icon
Change-Id: I50a093d4ee1352d7e8958148fec5d577b5eaf00d PiperOrigin-RevId: 163316612
-rw-r--r--site/BUILD7
-rw-r--r--src/main/cpp/BUILD6
-rw-r--r--src/main/native/windows/BUILD18
-rw-r--r--src/main/native/windows/compile-resources.sh46
-rw-r--r--src/main/native/windows/gen_vsenv_stub.sh67
5 files changed, 143 insertions, 1 deletions
diff --git a/site/BUILD b/site/BUILD
index 1672988fdb..061533bee6 100644
--- a/site/BUILD
+++ b/site/BUILD
@@ -8,6 +8,13 @@ exports_files(
],
)
+exports_files(
+ [
+ "images/favicon.ico",
+ ],
+ visibility = ["//src/main/native/windows:__pkg__"],
+)
+
DOT_GRAPH_HTML_FILES = [
"docs/query.html",
"docs/build-ref.html",
diff --git a/src/main/cpp/BUILD b/src/main/cpp/BUILD
index fc1880b5cb..8619eea015 100644
--- a/src/main/cpp/BUILD
+++ b/src/main/cpp/BUILD
@@ -82,7 +82,11 @@ cc_binary(
"global_variables.cc",
"global_variables.h",
"main.cc",
- ],
+ ] + select({
+ "//src:windows": ["//src/main/native/windows:resources"],
+ "//src:windows_msvc": ["//src/main/native/windows:resources"],
+ "//conditions:default": [],
+ }),
copts = select({
"//src:windows": ["/wd4018"],
"//src:windows_msvc": ["/wd4018"],
diff --git a/src/main/native/windows/BUILD b/src/main/native/windows/BUILD
index fe5873f37f..f4251a82b5 100644
--- a/src/main/native/windows/BUILD
+++ b/src/main/native/windows/BUILD
@@ -48,3 +48,21 @@ genrule(
"//src/tools/android/java/com/google/devtools/build/android:__subpackages__",
],
)
+
+genrule(
+ name = "resources",
+ srcs = ["//site:images/favicon.ico"],
+ outs = ["resources.o"],
+ cmd = " ".join([
+ "$(location compile-resources.sh)",
+ "$(location //site:images/favicon.ico)",
+ "$@",
+ "$(location gen_vsenv_stub.sh)",
+ ]),
+ output_to_bindir = 1,
+ tools = [
+ "compile-resources.sh",
+ "gen_vsenv_stub.sh",
+ ],
+ visibility = ["//src/main/cpp:__pkg__"],
+)
diff --git a/src/main/native/windows/compile-resources.sh b/src/main/native/windows/compile-resources.sh
new file mode 100644
index 0000000000..92f81dee01
--- /dev/null
+++ b/src/main/native/windows/compile-resources.sh
@@ -0,0 +1,46 @@
+#!/bin/bash -eu
+
+# Copyright 2017 The Bazel Authors. All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+ICON=$1
+OUTPUT=$2
+VCVARS_SETTER=$3
+
+export TMP="$(mktemp -d)"
+OWD=$(pwd)
+trap "cd \"$OWD\" && rm -fr \"$TMP\"" EXIT
+
+# Stage the source files in the temp directory.
+# The resource compiler generates its outputs next to its sources, and we don't
+# want to pollute the source tree with output files.
+mkdir -p "$TMP/$(dirname "$ICON")"
+cp $ICON $TMP/$ICON
+
+# Create the batch file that sets up the VC environment and runs the Resource
+# Compiler.
+RUNNER=$TMP/vs.bat
+"$VCVARS_SETTER" $RUNNER
+echo "@rc /nologo bazel.rc" >> $RUNNER
+chmod +x $RUNNER
+
+# Run the script and move the output to its final location.
+cd $TMP
+cat > bazel.rc <<EOF
+1 ICON "${ICON//\//\\}"
+EOF
+
+./vs.bat
+cd $OWD
+mv $TMP/bazel.res $OUTPUT
diff --git a/src/main/native/windows/gen_vsenv_stub.sh b/src/main/native/windows/gen_vsenv_stub.sh
new file mode 100644
index 0000000000..723cbf5d3e
--- /dev/null
+++ b/src/main/native/windows/gen_vsenv_stub.sh
@@ -0,0 +1,67 @@
+#!/bin/bash -eu
+
+# Copyright 2017 The Bazel Authors. All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+set -eu
+OUTPUT=$1
+
+function fail() {
+ echo >&2 "ERROR: $@"
+ exit 1
+}
+
+# Ensure the PATH is set up correctly.
+if ! which which >&/dev/null ; then
+ PATH="/bin:/usr/bin:$PATH"
+ which which >&/dev/null \
+ || fail "System PATH is not set up correctly, cannot run GNU bintools"
+fi
+
+# Find Visual Studio. We don't have any regular environment variables available
+# so this is the best we can do.
+if [ -z "${BAZEL_VS+set}" ]; then
+ VSVERSION="$(ls "C:/Program Files (x86)" \
+ | grep -E "Microsoft Visual Studio [0-9]+" \
+ | sort --version-sort \
+ | tail -n 1)"
+ [[ -n "$VSVERSION" ]] || fail "Visual Studio not found"
+ BAZEL_VS="C:/Program Files (x86)/$VSVERSION"
+fi
+VSVARS="${BAZEL_VS}/VC/VCVARSALL.BAT"
+
+# Check if Visual Studio 2017 is installed. Look for it at the default
+# locations.
+if [ ! -f "${VSVARS}" ]; then
+ VSVARS="C:/Program Files (x86)/Microsoft Visual Studio/2017/"
+ VSEDITION="BuildTools"
+ if [ -d "${VSVARS}Enterprise" ]; then
+ VSEDITION="Enterprise"
+ elif [ -d "${VSVARS}Professional" ]; then
+ VSEDITION="Professional"
+ elif [ -d "${VSVARS}Community" ]; then
+ VSEDITION="Community"
+ fi
+ VSVARS+="$VSEDITION/VC/Auxiliary/Build/VCVARSALL.BAT"
+fi
+
+if [ ! -f "${VSVARS}" ]; then
+ fail "VCVARSALL.bat not found, check your Visual Studio installation"
+fi
+
+cat > "$OUTPUT" <<EOF
+@call "${VSVARS}" amd64
+EOF
+
+chmod +x "$OUTPUT"